package ch.kri.fhbb.crypto.example1; 

import java.io.*;
import java.awt.*;
import javax.swing.*;
import java.security.*;
import javax.crypto.*;
import javax.crypto.spec.*; // for PBEParameterSpec

public class DesPassword extends javax.swing.JFrame {

     private static String inputArgs[];

     public static void main(String args[]) {
         if (args.length > 0) {
             inputArgs = new String[args.length];
             for (int i = 0 ; i < args.length ; i++) {
                 inputArgs[i] = args[i];
             }
         }
         new DesPassword().show();
    }
    
    /** Creates new form DesPassword */
    public DesPassword() {
        initComponents();
        if (inputArgs != null) {
            txtInputFile.setText(inputArgs[0]);
            if (inputArgs.length > 1) txtOutputFile.setText(inputArgs[1]);
            if (inputArgs.length > 2) txtPassword.setText(inputArgs[2]);
        }
        
        // Is JCE installed?
        try { Cipher c = Cipher.getInstance("PBEWithMD5AndDES"); }
        catch(Exception e) {
            ShowDialog errDialog = new ShowDialog("Error", "JCE is not installed");
        }
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        jLabel1 = new javax.swing.JLabel();
        txtInputFile = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        txtOutputFile = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        txtPassword = new javax.swing.JTextField();
        btnEncode = new javax.swing.JButton();
        btnDecode = new javax.swing.JButton();
        
        getContentPane().setLayout(new java.awt.GridLayout(4, 2));
        
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });
        
        jLabel1.setText("Input Datei");
        getContentPane().add(jLabel1);
        
        getContentPane().add(txtInputFile);
        
        jLabel2.setText("Output Datei");
        getContentPane().add(jLabel2);
        
        getContentPane().add(txtOutputFile);
        
        jLabel3.setText("Passwort");
        getContentPane().add(jLabel3);
        
        getContentPane().add(txtPassword);
        
        btnEncode.setText("Verschl\u00fcsseln");
        btnEncode.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                btnEncodeMouseClicked(evt);
            }
        });
        
        getContentPane().add(btnEncode);
        
        btnDecode.setText("Entschl\u00fcsseln");
        btnDecode.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                btnDecodeMouseClicked(evt);
            }
        });
        
        getContentPane().add(btnDecode);
        
        pack();
    }//GEN-END:initComponents

    private void btnDecodeMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btnDecodeMouseClicked
        crypt(Cipher.DECRYPT_MODE);
    }//GEN-LAST:event_btnDecodeMouseClicked

    private void btnEncodeMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btnEncodeMouseClicked
        crypt(Cipher.ENCRYPT_MODE);
    }//GEN-LAST:event_btnEncodeMouseClicked
    
    private void crypt(int direction) {
        File inFile;
        File outFile;
        FileInputStream fIn;
        FileOutputStream fOut;
        
        if (validateFields()) {
            try {
                inFile = new File(txtInputFile.getText());
                fIn = new FileInputStream(inFile);
            }
            catch(FileNotFoundException e) {
                ShowDialog errDialog = new ShowDialog("Error", "File not found: " + txtInputFile.getText());
                return;
            }
            
            try {
                outFile  = new File(txtOutputFile.getText());
                fOut = new FileOutputStream(outFile);
            }
            catch(FileNotFoundException e) {
                ShowDialog errDialog = new ShowDialog("Error", "File not found: " + txtOutputFile.getText());
                return;
            }
            
            try {
                // specify cipher parameters - these must be the same for encryption and
                // decryption, else it won't work...
                byte[] salt = { (byte)0x01, (byte)0x02, (byte)0x03, (byte)0x04,
                                (byte)0x05, (byte)0x06, (byte)0x07, (byte)0x08 };
                int iterationCount = 20;
                PBEParameterSpec pbeParamSpec = new PBEParameterSpec(salt, iterationCount);
            
                char[] keyData = txtPassword.getText().toCharArray();
                PBEKeySpec keySpec = new PBEKeySpec(keyData);
                SecretKeyFactory keyFactory = SecretKeyFactory.getInstance("PBEWithMD5AndDES");
                SecretKey key = keyFactory.generateSecret(keySpec);
            
                // get cipher object for password-based encryption
                Cipher pbeCipher = Cipher.getInstance("PBEWithMD5AndDES");
                pbeCipher.init(direction, key, pbeParamSpec);
            
                // now encrypt the input-file into the output-file
                byte[] buffer = new byte[2048];
                int bytesRead = fIn.read(buffer);
                while( bytesRead != -1 ) {
                    fOut.write(pbeCipher.update(buffer, 0, bytesRead));
                    bytesRead = fIn.read(buffer);
                }
                fOut.write(pbeCipher.doFinal());
                fOut.flush();
                fOut.close();
                fIn.close();
            }
            catch(Exception e) {
                ShowDialog errDialog = new ShowDialog("Error", e.getMessage());
            }
        }
    }
    
    private boolean validateFields() {
        if (txtInputFile.getText().compareTo("") == 0) {
            return false;
        } else if (txtOutputFile.getText().compareTo("") == 0) {
            return false;
        } else if (txtPassword.getText().compareTo("") == 0) {
            return false;
        } else {
            return true;
        }
    }
    
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        System.exit(0);
    }//GEN-LAST:event_exitForm

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel jLabel1;
    private javax.swing.JTextField txtInputFile;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JTextField txtOutputFile;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JTextField txtPassword;
    private javax.swing.JButton btnEncode;
    private javax.swing.JButton btnDecode;
    // End of variables declaration//GEN-END:variables

}

class ShowDialog extends javax.swing.JFrame {
    public ShowDialog(String title, String message) {
            JFrame errorDialog = new JFrame(title);
            Container frameContent = errorDialog.getContentPane();
            frameContent.setLayout(new GridLayout(1,1));
            JLabel lblError = new JLabel("");
            frameContent.add(lblError);
            lblError.setText(message);
            errorDialog.pack();
            errorDialog.setLocation(100,100);
            errorDialog.setVisible(true);
    }
}